/*
Stylus variables are information about icon's compiled state, stored under its original file name

.icon-home {
  width: $icon_home_width;
}

The large array-like variables contain all information about a single icon
$icon_home = x y offset_x offset_y width height total_width total_height image_path;

At the bottom of this section, we provide information about the spritesheet itself
$spritesheet = width height image $spritesheet_sprites;
*/
$heart_name = 'heart';
$heart_x = 0px;
$heart_y = 0px;
$heart_offset_x = 0px;
$heart_offset_y = 0px;
$heart_width = 16px;
$heart_height = 16px;
$heart_total_width = 52px;
$heart_total_height = 34px;
$heart_image = '../img/sprite.png';
$heart = 0px 0px 0px 0px 16px 16px 52px 34px '../img/sprite.png' 'heart';
$instagram_logo_name = 'instagram-logo';
$instagram_logo_x = 18px;
$instagram_logo_y = 0px;
$instagram_logo_offset_x = -18px;
$instagram_logo_offset_y = 0px;
$instagram_logo_width = 16px;
$instagram_logo_height = 16px;
$instagram_logo_total_width = 52px;
$instagram_logo_total_height = 34px;
$instagram_logo_image = '../img/sprite.png';
$instagram_logo = 18px 0px -18px 0px 16px 16px 52px 34px '../img/sprite.png' 'instagram-logo';
$star_name = 'star';
$star_x = 0px;
$star_y = 18px;
$star_offset_x = 0px;
$star_offset_y = -18px;
$star_width = 16px;
$star_height = 16px;
$star_total_width = 52px;
$star_total_height = 34px;
$star_image = '../img/sprite.png';
$star = 0px 18px 0px -18px 16px 16px 52px 34px '../img/sprite.png' 'star';
$view_name = 'view';
$view_x = 18px;
$view_y = 18px;
$view_offset_x = -18px;
$view_offset_y = -18px;
$view_width = 16px;
$view_height = 16px;
$view_total_width = 52px;
$view_total_height = 34px;
$view_image = '../img/sprite.png';
$view = 18px 18px -18px -18px 16px 16px 52px 34px '../img/sprite.png' 'view';
$view2_name = 'view2';
$view2_x = 36px;
$view2_y = 0px;
$view2_offset_x = -36px;
$view2_offset_y = 0px;
$view2_width = 16px;
$view2_height = 16px;
$view2_total_width = 52px;
$view2_total_height = 34px;
$view2_image = '../img/sprite.png';
$view2 = 36px 0px -36px 0px 16px 16px 52px 34px '../img/sprite.png' 'view2';
$spritesheet_width = 52px;
$spritesheet_height = 34px;
$spritesheet_image = '../img/sprite.png';
$spritesheet_sprites = $heart $instagram_logo $star $view $view2;
$spritesheet = 52px 34px '../img/sprite.png' $spritesheet_sprites;

/*
The provided mixins are intended to be used with the array-like variables

.icon-home {
  spriteWidth($icon_home)
}

.icon-email {
  sprite($icon_email)
}

Example usage in HTML:

`display: block` sprite:
<div class="icon-home"></div>

To change `display` (e.g. `display: inline-block;`), we suggest using a common CSS class:

// CSS
.icon {
  display: inline-block;
}

// HTML
<i class="icon icon-home"></i>
*/
spriteWidth($sprite) {
  width: $sprite[4];
}

spriteHeight($sprite) {
  height: $sprite[5];
}

spritePosition($sprite) {
  background-position: $sprite[2] $sprite[3];
}

spriteImage($sprite) {
  background-image: url($sprite[8]);
}

sprite($sprite) {
  spriteImage($sprite)
  spritePosition($sprite)
  spriteWidth($sprite)
  spriteHeight($sprite)
}

/*
The `sprites` mixin generates identical output to the CSS template
  but can be overridden inside of Stylus

This must be run when you have at least 2 sprites.
  If run with a single sprite, then there will be reference errors.

sprites($spritesheet_sprites);
*/
sprites($sprites) {
  for $sprite in $sprites {
    $sprite_name = $sprite[9];
    .{$sprite_name} {
      sprite($sprite);
    }
  }
}
